
!TOMethodSourceBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 6/16/2011 13:13'!
accept: aString
	| newSelector |
	newSelector := [ self methodClass compile: aString classified: self methodCategory notifying: nil ]
		on: SyntaxErrorNotification
		do: [ :ex | 
			methodSource := (aString copyFrom: 1 to: ex location) , ex errorMessage , '-->'
				, (aString copyFrom: ex location + 1 to: aString size).
			^ nil ].
	methodSource := nil.
	newSelector == self selectedMethodSelector
		ifTrue: [ ^ self ].
	self methodReference: (MethodReference class: self methodClass selector: newSelector).
	self methodCategoryBrowser selectedSelector: newSelector! !

!TOMethodSourceBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/30/2011 20:42'!
moveMethodTo: cat

	self methodClass organization 
		classify: self selectedMethodSelector
		under: cat
		suppressIfDefault: false.
	self methodReference category: nil.! !

!TOSearch methodsFor: '*tode-pharo-code' stamp: 'dkh 6/13/2011 07:41'!
classQueryResults
	<todeSearch: 'Class' selector: #classSearch priority: 1>
	^self classResultsFor: [:cl | self classSatisfiesQuery: cl query: searchText]! !

!TOSearch methodsFor: '*tode-pharo-code' stamp: 'dkh 6/3/2011 16:01'!
classResultsFor: queryBlock
	^ self currentSystem allClasses select: [ :ea | queryBlock value: ea ]! !

!TOSearch methodsFor: '*tode-pharo-code' stamp: 'dkh 6/16/2011 15:52'!
implementorsExactQueryResults
	<todeSearch: 'Implementors (exact)' selector: #implementorsExactSearch priority: 9>
	| methods |
	methods := Set new.
	(self currentSystem allClassesImplementing: searchText) do: [:cl | 
		methods add: (self currentSystem methodReferenceClass class: cl selector: searchText )].
	^ methods asArray sorted: [:a :b | a selector <= b selector ]! !

!TOSearch methodsFor: '*tode-pharo-code' stamp: 'dkh 6/16/2011 15:51'!
implementorsQueryResults
	<todeSearch: 'Implementors' selector: #implementorsSearch priority: 10>
	| methods |
	methods := Set new.
	(Symbol selectorsContaining: searchText) 
		do: [:ea | (self currentSystem allClassesImplementing: ea) do: [:cl | 
				methods add: (self currentSystem methodReferenceClass class: cl selector: ea )]].
	^ methods asArray sorted: [:a :b | a selector <= b selector ]! !

!TOSearch methodsFor: '*tode-pharo-code' stamp: 'dkh 6/16/2011 15:52'!
sendersExactQueryResults
	<todeSearch: 'Senders (exact)' selector: #sendersExactSearch priority: 14>
	^(self currentSystem allReferencesTo: searchText asSymbol) asSet asArray sorted! !

!TOSearch methodsFor: '*tode-pharo-code' stamp: 'dkh 6/16/2011 15:51'!
sendersQueryResults
	<todeSearch: 'Senders' selector: #sendersSearch priority: 15>
	| methods |
	methods := Set new.
	(Symbol selectorsContaining: searchText) 
		do: [:ea | methods addAll: (self currentSystem allReferencesTo: ea)].
	^ methods asArray sorted! !

!TOMethodCategoryBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 6/13/2011 13:25'!
selectorsForCategory: cat

	^(cat = self allCategory
		ifTrue: [ self theClass selectors ]
		ifFalse: [ self theClass organization listAtCategoryNamed: cat ]) asArray.! !

!TOMethodCategoryBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/26/2011 12:20'!
sortedCategories

	^self theClass organization categories asArray sorted: [:a :b | a <= b ].! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/24/2011 00:29'!
acessesToCV: classVarName from: aClass
	
	^(SystemNavigation default) allCallsOn: (aClass classPool associationAt: classVarName )
! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/24/2011 00:26'!
acessesToIV: instVarName from: aClass
	| coll |
	coll := OrderedCollection new.
	aClass
		withAllSubAndSuperclassesDo: [ :class | 
			(class whichSelectorsAccess: instVarName)
				do: [ :sel | 
					sel isDoIt
						ifFalse: [ coll add: (SourcedMethodReference new setClass: class methodSymbol: sel) ] ] ].
	^ coll! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 5/24/2011 00:44'!
classDefinitionTemplate: classTemplateType
	| stream |
	classTemplateType == #new
		ifTrue: [ ^ Class templateForSubclassOf: Object name category: self theClass theNonMetaClass category ].

	classTemplateType == #subclass
		ifTrue: [ ^ Class templateForSubclassOf: self theClass name category: self theClass theNonMetaClass category ].
		
	"classTemplateType == #definition"
	stream := WriteStream on: String new.
	stream
		nextPutAll: self theClass definition;
		nextPut: $.;
		cr;
		cr;
		nextPutAll: self theClass class definition;
		nextPut: $.;
		cr.
	^ stream contents! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 6/3/2011 15:11'!
copyClass: main script: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 6/3/2011 15:11'!
removeClass: main script: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 6/3/2011 15:11'!
renameClass: main script: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-code' stamp: 'dkh 6/3/2011 17:01'!
renderClassExplorerOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			html break.
			self
				renderLink: [ :s | 
					self currentSession push: self theClass superclass allCallsOn selecting: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass superclass name ]
				on: html.
			html text: ' subclass: '.
			self
				renderLink: [ :s | 
					self currentSession push: self theClass allCallsOn selecting: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name ]
				on: html.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									self currentSession push: (self acessesToIV: iv from: self theClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'classVariableNames: '.
					self theClass classVarNames
						do: [ :cv | 
							html space.
							self
								renderLink: [ :s | 
									self currentSession push: (self acessesToCV: cv from: self theClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: cv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'poolDictionaries: '.
					self theClass theNonMetaClass poolDictionaryNames
						do: [ :sp | 
							self
								renderLink: [ :s | 
									self currentSession
										push:
											(SystemNavigation default allReferencesToPool: (Smalltalk globals at: sp asSymbol) from: self theClass theNonMetaClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: sp ]
								on: html ] ].
			html
				unorderedList: [ 
					| cat |
					html text: 'category: '.
					cat := self theClass theNonMetaClass category.
					self
						renderLink: [ :s | 
							self currentSession push: (SystemOrganization classesInCategory: cat) selecting: #inspect.
							main updateCenterSideHistory: s ]
						with: [ html strong: cat ]
						on: html ].
			html break.
			self
				renderLink: [ :s | 
					self currentSession push: self theClass class allCallsOn selecting: #inspect..
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name , ' class' ]
				on: html.
			html break.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass class instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									self currentSession push: (self acessesToIV: iv from: self theClass) selecting: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ] ]
		on: html! !
